/* DeviceRow.c generated by valac 0.34.4, the Vala compiler
 * generated from DeviceRow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>


#define BLUETOOTH_TYPE_DEVICE_ROW (bluetooth_device_row_get_type ())
#define BLUETOOTH_DEVICE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow))
#define BLUETOOTH_DEVICE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRowClass))
#define BLUETOOTH_IS_DEVICE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_TYPE_DEVICE_ROW))
#define BLUETOOTH_IS_DEVICE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BLUETOOTH_TYPE_DEVICE_ROW))
#define BLUETOOTH_DEVICE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRowClass))

typedef struct _BluetoothDeviceRow BluetoothDeviceRow;
typedef struct _BluetoothDeviceRowClass BluetoothDeviceRowClass;
typedef struct _BluetoothDeviceRowPrivate BluetoothDeviceRowPrivate;

#define BLUETOOTH_SERVICES_TYPE_DEVICE (bluetooth_services_device_get_type ())
#define BLUETOOTH_SERVICES_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDevice))
#define BLUETOOTH_SERVICES_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE))
#define BLUETOOTH_SERVICES_DEVICE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_SERVICES_TYPE_DEVICE, BluetoothServicesDeviceIface))

typedef struct _BluetoothServicesDevice BluetoothServicesDevice;
typedef struct _BluetoothServicesDeviceIface BluetoothServicesDeviceIface;

#define BLUETOOTH_SERVICES_TYPE_DEVICE_PROXY (bluetooth_services_device_proxy_get_type ())

#define BLUETOOTH_SERVICES_TYPE_ADAPTER (bluetooth_services_adapter_get_type ())
#define BLUETOOTH_SERVICES_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapter))
#define BLUETOOTH_SERVICES_IS_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER))
#define BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapterIface))

typedef struct _BluetoothServicesAdapter BluetoothServicesAdapter;
typedef struct _BluetoothServicesAdapterIface BluetoothServicesAdapterIface;

#define BLUETOOTH_SERVICES_TYPE_ADAPTER_PROXY (bluetooth_services_adapter_proxy_get_type ())

#define BLUETOOTH_DEVICE_ROW_TYPE_STATUS (bluetooth_device_row_status_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block3Data Block3Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))

struct _BluetoothDeviceRow {
	GtkListBoxRow parent_instance;
	BluetoothDeviceRowPrivate * priv;
};

struct _BluetoothDeviceRowClass {
	GtkListBoxRowClass parent_class;
};

struct _BluetoothServicesDeviceIface {
	GTypeInterface parent_iface;
	void (*cancel_pairing) (BluetoothServicesDevice* self, GError** error);
	void (*connect) (BluetoothServicesDevice* self, GError** error);
	void (*connect_profile) (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
	void (*disconnect) (BluetoothServicesDevice* self, GError** error);
	void (*disconnect_profile) (BluetoothServicesDevice* self, const gchar* UUID, GError** error);
	void (*pair) (BluetoothServicesDevice* self, GError** error);
	gchar** (*get_UUIDs) (BluetoothServicesDevice* self, int* result_length1);
	void (*set_UUIDs) (BluetoothServicesDevice* self, gchar** value, int value_length1);
	gboolean (*get_blocked) (BluetoothServicesDevice* self);
	void (*set_blocked) (BluetoothServicesDevice* self, gboolean value);
	gboolean (*get_connected) (BluetoothServicesDevice* self);
	void (*set_connected) (BluetoothServicesDevice* self, gboolean value);
	gboolean (*get_legacy_pairing) (BluetoothServicesDevice* self);
	void (*set_legacy_pairing) (BluetoothServicesDevice* self, gboolean value);
	gboolean (*get_paired) (BluetoothServicesDevice* self);
	void (*set_paired) (BluetoothServicesDevice* self, gboolean value);
	gboolean (*get_trusted) (BluetoothServicesDevice* self);
	void (*set_trusted) (BluetoothServicesDevice* self, gboolean value);
	gint16 (*get_RSSI) (BluetoothServicesDevice* self);
	void (*set_RSSI) (BluetoothServicesDevice* self, gint16 value);
	char* (*get_adapter) (BluetoothServicesDevice* self);
	void (*set_adapter) (BluetoothServicesDevice* self, const char* value);
	gchar* (*get_address) (BluetoothServicesDevice* self);
	void (*set_address) (BluetoothServicesDevice* self, const gchar* value);
	gchar* (*get_alias) (BluetoothServicesDevice* self);
	void (*set_alias) (BluetoothServicesDevice* self, const gchar* value);
	gchar* (*get_icon) (BluetoothServicesDevice* self);
	void (*set_icon) (BluetoothServicesDevice* self, const gchar* value);
	gchar* (*get_modalias) (BluetoothServicesDevice* self);
	void (*set_modalias) (BluetoothServicesDevice* self, const gchar* value);
	gchar* (*get_name) (BluetoothServicesDevice* self);
	void (*set_name) (BluetoothServicesDevice* self, const gchar* value);
	guint16 (*get_appearance) (BluetoothServicesDevice* self);
	void (*set_appearance) (BluetoothServicesDevice* self, guint16 value);
	guint32 (*get_class) (BluetoothServicesDevice* self);
	void (*set_class) (BluetoothServicesDevice* self, guint32 value);
};

struct _BluetoothServicesAdapterIface {
	GTypeInterface parent_iface;
	void (*remove_device) (BluetoothServicesAdapter* self, const char* device, GError** error);
	void (*set_discovery_filter) (BluetoothServicesAdapter* self, GHashTable* properties, GError** error);
	void (*start_discovery) (BluetoothServicesAdapter* self, GError** error);
	void (*stop_discovery) (BluetoothServicesAdapter* self, GError** error);
	gchar** (*get_UUIDs) (BluetoothServicesAdapter* self, int* result_length1);
	void (*set_UUIDs) (BluetoothServicesAdapter* self, gchar** value, int value_length1);
	gboolean (*get_discoverable) (BluetoothServicesAdapter* self);
	void (*set_discoverable) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_discovering) (BluetoothServicesAdapter* self);
	void (*set_discovering) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_pairable) (BluetoothServicesAdapter* self);
	void (*set_pairable) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_powered) (BluetoothServicesAdapter* self);
	void (*set_powered) (BluetoothServicesAdapter* self, gboolean value);
	gchar* (*get_address) (BluetoothServicesAdapter* self);
	void (*set_address) (BluetoothServicesAdapter* self, const gchar* value);
	gchar* (*get_alias) (BluetoothServicesAdapter* self);
	void (*set_alias) (BluetoothServicesAdapter* self, const gchar* value);
	gchar* (*get_modalias) (BluetoothServicesAdapter* self);
	void (*set_modalias) (BluetoothServicesAdapter* self, const gchar* value);
	gchar* (*get_name) (BluetoothServicesAdapter* self);
	void (*set_name) (BluetoothServicesAdapter* self, const gchar* value);
	guint (*get_class) (BluetoothServicesAdapter* self);
	void (*set_class) (BluetoothServicesAdapter* self, guint value);
	guint (*get_discoverable_timeout) (BluetoothServicesAdapter* self);
	void (*set_discoverable_timeout) (BluetoothServicesAdapter* self, guint value);
	guint (*get_pairable_timeout) (BluetoothServicesAdapter* self);
	void (*set_pairable_timeout) (BluetoothServicesAdapter* self, guint value);
};

struct _BluetoothDeviceRowPrivate {
	BluetoothServicesDevice* _device;
	BluetoothServicesAdapter* _adapter;
	GtkButton* connect_button;
	GtkImage* state;
	GtkLabel* state_label;
};

typedef enum  {
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT
} BluetoothDeviceRowStatus;

struct _Block3Data {
	int _ref_count_;
	BluetoothDeviceRow* self;
	GtkImage* image;
	GtkLabel* label;
};


static gpointer bluetooth_device_row_parent_class = NULL;
static GtkSizeGroup* bluetooth_device_row_size_group;
static GtkSizeGroup* bluetooth_device_row_size_group = NULL;

GType bluetooth_device_row_get_type (void) G_GNUC_CONST;
GType bluetooth_services_device_proxy_get_type (void) G_GNUC_CONST;
guint bluetooth_services_device_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType bluetooth_services_device_get_type (void) G_GNUC_CONST;
GType bluetooth_services_adapter_proxy_get_type (void) G_GNUC_CONST;
guint bluetooth_services_adapter_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType bluetooth_services_adapter_get_type (void) G_GNUC_CONST;
#define BLUETOOTH_DEVICE_ROW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRowPrivate))
enum  {
	BLUETOOTH_DEVICE_ROW_DUMMY_PROPERTY,
	BLUETOOTH_DEVICE_ROW_DEVICE,
	BLUETOOTH_DEVICE_ROW_ADAPTER
};
static GType bluetooth_device_row_status_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gchar* bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self);
BluetoothDeviceRow* bluetooth_device_row_new (BluetoothServicesDevice* device, BluetoothServicesAdapter* adapter);
BluetoothDeviceRow* bluetooth_device_row_construct (GType object_type, BluetoothServicesDevice* device, BluetoothServicesAdapter* adapter);
static void bluetooth_device_row_set_status (BluetoothDeviceRow* self, BluetoothDeviceRowStatus status);
BluetoothServicesDevice* bluetooth_device_row_get_device (BluetoothDeviceRow* self);
static void bluetooth_device_row_set_device (BluetoothDeviceRow* self, BluetoothServicesDevice* value);
BluetoothServicesAdapter* bluetooth_device_row_get_adapter (BluetoothDeviceRow* self);
static void bluetooth_device_row_set_adapter (BluetoothDeviceRow* self, BluetoothServicesAdapter* value);
static GObject * bluetooth_device_row_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
gchar* bluetooth_services_device_get_icon (BluetoothServicesDevice* self);
gchar* bluetooth_services_device_get_address (BluetoothServicesDevice* self);
gchar* bluetooth_services_device_get_name (BluetoothServicesDevice* self);
gboolean bluetooth_services_device_get_connected (BluetoothServicesDevice* self);
gboolean bluetooth_services_adapter_get_powered (BluetoothServicesAdapter* self);
static void _bluetooth_device_row___lambda8_ (BluetoothDeviceRow* self, GVariant* changed, gchar** invalid, int invalid_length1);
static void __bluetooth_device_row___lambda8__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender, GVariant* changed_properties, gchar** invalidated_properties, gpointer self);
static void _bluetooth_device_row___lambda9_ (Block3Data* _data3_, GVariant* changed, gchar** invalid, int invalid_length1);
static void __bluetooth_device_row___lambda9__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender, GVariant* changed_properties, gchar** invalidated_properties, gpointer self);
static void _bluetooth_device_row___lambda10_ (BluetoothDeviceRow* self);
static void* ___lambda11_ (BluetoothDeviceRow* self);
void bluetooth_services_device_connect (BluetoothServicesDevice* self, GError** error);
static gpointer ____lambda11__gthread_func (gpointer self);
static void* ___lambda12_ (BluetoothDeviceRow* self);
void bluetooth_services_device_disconnect (BluetoothServicesDevice* self, GError** error);
static gpointer ____lambda12__gthread_func (gpointer self);
static void __bluetooth_device_row___lambda10__gtk_button_clicked (GtkButton* _sender, gpointer self);
static void bluetooth_device_row_finalize (GObject* obj);
static void _vala_bluetooth_device_row_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_bluetooth_device_row_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static gint _vala_array_length (gpointer array);


static gchar* bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self) {
	gchar* result = NULL;
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	switch (self) {
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
#line 240 "DeviceRow.c"
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_ = NULL;
#line 36 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp0_ = _ ("Connected");
#line 36 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp1_ = g_strdup (_tmp0_);
#line 36 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			result = _tmp1_;
#line 36 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			return result;
#line 252 "DeviceRow.c"
		}
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
#line 256 "DeviceRow.c"
		{
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
#line 38 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp2_ = _ ("Connecting…");
#line 38 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 38 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			result = _tmp3_;
#line 38 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			return result;
#line 268 "DeviceRow.c"
		}
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
#line 272 "DeviceRow.c"
		{
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_ = NULL;
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp4_ = _ ("Disconnecting…");
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp5_ = g_strdup (_tmp4_);
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			result = _tmp5_;
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			return result;
#line 284 "DeviceRow.c"
		}
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
#line 288 "DeviceRow.c"
		{
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
#line 42 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp6_ = _ ("Unable to Connnect");
#line 42 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 42 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			result = _tmp7_;
#line 42 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			return result;
#line 300 "DeviceRow.c"
		}
		default:
		{
			const gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
#line 44 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp8_ = _ ("Not Connected");
#line 44 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 44 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			result = _tmp9_;
#line 44 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			return result;
#line 314 "DeviceRow.c"
		}
	}
}


static GType bluetooth_device_row_status_get_type (void) {
	static volatile gsize bluetooth_device_row_status_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_device_row_status_type_id__volatile)) {
		static const GEnumValue values[] = {{BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED", "connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING", "connecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING", "disconnecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED", "not-connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT, "BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT", "unable-to-connect"}, {0, NULL, NULL}};
		GType bluetooth_device_row_status_type_id;
		bluetooth_device_row_status_type_id = g_enum_register_static ("BluetoothDeviceRowStatus", values);
		g_once_init_leave (&bluetooth_device_row_status_type_id__volatile, bluetooth_device_row_status_type_id);
	}
	return bluetooth_device_row_status_type_id__volatile;
}


BluetoothDeviceRow* bluetooth_device_row_construct (GType object_type, BluetoothServicesDevice* device, BluetoothServicesAdapter* adapter) {
	BluetoothDeviceRow * self = NULL;
	BluetoothServicesDevice* _tmp0_ = NULL;
	BluetoothServicesAdapter* _tmp1_ = NULL;
#line 53 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 53 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_return_val_if_fail (adapter != NULL, NULL);
#line 54 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp0_ = device;
#line 54 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp1_ = adapter;
#line 54 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	self = (BluetoothDeviceRow*) g_object_new (object_type, "device", _tmp0_, "adapter", _tmp1_, NULL);
#line 53 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	return self;
#line 348 "DeviceRow.c"
}


BluetoothDeviceRow* bluetooth_device_row_new (BluetoothServicesDevice* device, BluetoothServicesAdapter* adapter) {
#line 53 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	return bluetooth_device_row_construct (BLUETOOTH_TYPE_DEVICE_ROW, device, adapter);
#line 355 "DeviceRow.c"
}


static void bluetooth_device_row_set_status (BluetoothDeviceRow* self, BluetoothDeviceRowStatus status) {
	GtkLabel* _tmp0_ = NULL;
	BluetoothDeviceRowStatus _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	BluetoothDeviceRowStatus _tmp6_ = 0;
#line 193 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 194 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp0_ = self->priv->state_label;
#line 194 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp1_ = status;
#line 194 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp2_ = bluetooth_device_row_status_to_string (_tmp1_);
#line 194 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp3_ = _tmp2_;
#line 194 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp4_ = g_markup_printf_escaped ("<span font_size='small'>%s</span>", _tmp3_);
#line 194 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp5_ = _tmp4_;
#line 194 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_label_set_label (_tmp0_, _tmp5_);
#line 194 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_free0 (_tmp5_);
#line 194 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_free0 (_tmp3_);
#line 196 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp6_ = status;
#line 196 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	switch (_tmp6_) {
#line 196 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
#line 393 "DeviceRow.c"
		{
			GtkButton* _tmp7_ = NULL;
			const gchar* _tmp8_ = NULL;
			GtkButton* _tmp9_ = NULL;
			GtkImage* _tmp10_ = NULL;
#line 198 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp7_ = self->priv->connect_button;
#line 198 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp8_ = _ ("Disconnect");
#line 198 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			gtk_button_set_label (_tmp7_, _tmp8_);
#line 199 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp9_ = self->priv->connect_button;
#line 199 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp9_, TRUE);
#line 200 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp10_ = self->priv->state;
#line 200 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			g_object_set (_tmp10_, "icon-name", "user-available", NULL);
#line 201 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			break;
#line 415 "DeviceRow.c"
		}
#line 196 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
#line 419 "DeviceRow.c"
		{
			GtkButton* _tmp11_ = NULL;
			GtkImage* _tmp12_ = NULL;
#line 203 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp11_ = self->priv->connect_button;
#line 203 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
#line 204 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp12_ = self->priv->state;
#line 204 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			g_object_set (_tmp12_, "icon-name", "user-away", NULL);
#line 205 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			break;
#line 433 "DeviceRow.c"
		}
#line 196 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
#line 437 "DeviceRow.c"
		{
			GtkButton* _tmp13_ = NULL;
			GtkImage* _tmp14_ = NULL;
#line 207 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp13_ = self->priv->connect_button;
#line 207 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, FALSE);
#line 208 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp14_ = self->priv->state;
#line 208 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			g_object_set (_tmp14_, "icon-name", "user-away", NULL);
#line 209 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			break;
#line 451 "DeviceRow.c"
		}
#line 196 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED:
#line 455 "DeviceRow.c"
		{
			GtkButton* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			GtkButton* _tmp17_ = NULL;
			GtkImage* _tmp18_ = NULL;
#line 211 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp15_ = self->priv->connect_button;
#line 211 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp16_ = _ ("Connect");
#line 211 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			gtk_button_set_label (_tmp15_, _tmp16_);
#line 212 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp17_ = self->priv->connect_button;
#line 212 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, TRUE);
#line 213 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp18_ = self->priv->state;
#line 213 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			g_object_set (_tmp18_, "icon-name", "user-offline", NULL);
#line 214 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			break;
#line 477 "DeviceRow.c"
		}
#line 196 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
#line 481 "DeviceRow.c"
		{
			GtkButton* _tmp19_ = NULL;
			GtkImage* _tmp20_ = NULL;
#line 216 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp19_ = self->priv->connect_button;
#line 216 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, TRUE);
#line 217 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			_tmp20_ = self->priv->state;
#line 217 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			g_object_set (_tmp20_, "icon-name", "user-busy", NULL);
#line 218 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			break;
#line 495 "DeviceRow.c"
		}
		default:
#line 196 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		break;
#line 500 "DeviceRow.c"
	}
}


BluetoothServicesDevice* bluetooth_device_row_get_device (BluetoothDeviceRow* self) {
	BluetoothServicesDevice* result;
	BluetoothServicesDevice* _tmp0_ = NULL;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp0_ = self->priv->_device;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	result = _tmp0_;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	return result;
#line 516 "DeviceRow.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 523 "DeviceRow.c"
}


static void bluetooth_device_row_set_device (BluetoothDeviceRow* self, BluetoothServicesDevice* value) {
	BluetoothServicesDevice* _tmp0_ = NULL;
	BluetoothServicesDevice* _tmp1_ = NULL;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp0_ = value;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (self->priv->_device);
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	self->priv->_device = _tmp1_;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_notify ((GObject *) self, "device");
#line 542 "DeviceRow.c"
}


BluetoothServicesAdapter* bluetooth_device_row_get_adapter (BluetoothDeviceRow* self) {
	BluetoothServicesAdapter* result;
	BluetoothServicesAdapter* _tmp0_ = NULL;
#line 23 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp0_ = self->priv->_adapter;
#line 23 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	result = _tmp0_;
#line 23 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	return result;
#line 557 "DeviceRow.c"
}


static void bluetooth_device_row_set_adapter (BluetoothDeviceRow* self, BluetoothServicesAdapter* value) {
	BluetoothServicesAdapter* _tmp0_ = NULL;
#line 23 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 23 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp0_ = value;
#line 23 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	self->priv->_adapter = _tmp0_;
#line 23 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_notify ((GObject *) self, "adapter");
#line 571 "DeviceRow.c"
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	return _data3_;
#line 580 "DeviceRow.c"
}


static void block3_data_unref (void * _userdata_) {
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 589 "DeviceRow.c"
		BluetoothDeviceRow* self;
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		self = _data3_->self;
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_g_object_unref0 (_data3_->label);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_g_object_unref0 (_data3_->image);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_g_object_unref0 (self);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		g_slice_free (Block3Data, _data3_);
#line 601 "DeviceRow.c"
	}
}


static void _bluetooth_device_row___lambda8_ (BluetoothDeviceRow* self, GVariant* changed, gchar** invalid, int invalid_length1) {
	GVariant* powered = NULL;
	GVariant* _tmp0_ = NULL;
	GVariantType* _tmp1_ = NULL;
	GVariantType* _tmp2_ = NULL;
	GVariant* _tmp3_ = NULL;
	GVariant* _tmp4_ = NULL;
	GVariant* _tmp5_ = NULL;
#line 138 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_return_if_fail (changed != NULL);
#line 139 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp0_ = changed;
#line 139 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp1_ = g_variant_type_new ("b");
#line 139 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp2_ = _tmp1_;
#line 139 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp3_ = g_variant_lookup_value (_tmp0_, "Powered", _tmp2_);
#line 139 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp4_ = _tmp3_;
#line 139 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp2_);
#line 139 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	powered = _tmp4_;
#line 140 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp5_ = powered;
#line 140 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	if (_tmp5_ != NULL) {
#line 634 "DeviceRow.c"
		BluetoothServicesAdapter* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
#line 141 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp6_ = self->priv->_adapter;
#line 141 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp7_ = bluetooth_services_adapter_get_powered (_tmp6_);
#line 141 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp8_ = _tmp7_;
#line 141 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self, _tmp8_);
#line 646 "DeviceRow.c"
	}
#line 138 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_variant_unref0 (powered);
#line 650 "DeviceRow.c"
}


static void __bluetooth_device_row___lambda8__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender, GVariant* changed_properties, gchar** invalidated_properties, gpointer self) {
#line 138 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_bluetooth_device_row___lambda8_ ((BluetoothDeviceRow*) self, changed_properties, invalidated_properties, _vala_array_length (invalidated_properties));
#line 657 "DeviceRow.c"
}


static void _bluetooth_device_row___lambda9_ (Block3Data* _data3_, GVariant* changed, gchar** invalid, int invalid_length1) {
	BluetoothDeviceRow* self;
	GVariant* connected = NULL;
	GVariant* _tmp0_ = NULL;
	GVariantType* _tmp1_ = NULL;
	GVariantType* _tmp2_ = NULL;
	GVariant* _tmp3_ = NULL;
	GVariant* _tmp4_ = NULL;
	GVariant* _tmp5_ = NULL;
	GVariant* name = NULL;
	GVariant* _tmp9_ = NULL;
	GVariantType* _tmp10_ = NULL;
	GVariantType* _tmp11_ = NULL;
	GVariant* _tmp12_ = NULL;
	GVariant* _tmp13_ = NULL;
	GVariant* _tmp14_ = NULL;
	GVariant* icon = NULL;
	GVariant* _tmp20_ = NULL;
	GVariantType* _tmp21_ = NULL;
	GVariantType* _tmp22_ = NULL;
	GVariant* _tmp23_ = NULL;
	GVariant* _tmp24_ = NULL;
	GVariant* _tmp25_ = NULL;
#line 145 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	self = _data3_->self;
#line 145 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_return_if_fail (changed != NULL);
#line 146 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp0_ = changed;
#line 146 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp1_ = g_variant_type_new ("b");
#line 146 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp2_ = _tmp1_;
#line 146 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp3_ = g_variant_lookup_value (_tmp0_, "Connected", _tmp2_);
#line 146 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp4_ = _tmp3_;
#line 146 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp2_);
#line 146 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	connected = _tmp4_;
#line 147 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp5_ = connected;
#line 147 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	if (_tmp5_ != NULL) {
#line 706 "DeviceRow.c"
		BluetoothServicesDevice* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
#line 148 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp6_ = self->priv->_device;
#line 148 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp7_ = bluetooth_services_device_get_connected (_tmp6_);
#line 148 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp8_ = _tmp7_;
#line 148 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		if (_tmp8_) {
#line 149 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED);
#line 720 "DeviceRow.c"
		} else {
#line 151 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED);
#line 724 "DeviceRow.c"
		}
	}
#line 155 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp9_ = changed;
#line 155 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp10_ = g_variant_type_new ("s");
#line 155 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp11_ = _tmp10_;
#line 155 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp12_ = g_variant_lookup_value (_tmp9_, "Name", _tmp11_);
#line 155 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp13_ = _tmp12_;
#line 155 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp11_);
#line 155 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	name = _tmp13_;
#line 156 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp14_ = name;
#line 156 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	if (_tmp14_ != NULL) {
#line 745 "DeviceRow.c"
		GtkLabel* _tmp15_ = NULL;
		BluetoothServicesDevice* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
#line 157 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp15_ = _data3_->label;
#line 157 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp16_ = self->priv->_device;
#line 157 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp17_ = bluetooth_services_device_get_name (_tmp16_);
#line 157 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp18_ = _tmp17_;
#line 157 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp19_ = _tmp18_;
#line 157 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		gtk_label_set_label (_tmp15_, _tmp19_);
#line 157 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_g_free0 (_tmp19_);
#line 765 "DeviceRow.c"
	}
#line 160 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp20_ = changed;
#line 160 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp21_ = g_variant_type_new ("s");
#line 160 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp22_ = _tmp21_;
#line 160 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp23_ = g_variant_lookup_value (_tmp20_, "Icon", _tmp22_);
#line 160 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp24_ = _tmp23_;
#line 160 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_variant_type_free0 (_tmp22_);
#line 160 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	icon = _tmp24_;
#line 161 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp25_ = icon;
#line 161 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	if (_tmp25_ != NULL) {
#line 785 "DeviceRow.c"
		GtkImage* _tmp26_ = NULL;
		BluetoothServicesDevice* _tmp27_ = NULL;
		gchar* _tmp28_ = NULL;
		gchar* _tmp29_ = NULL;
		gchar* _tmp30_ = NULL;
#line 162 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp26_ = _data3_->image;
#line 162 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp27_ = self->priv->_device;
#line 162 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp28_ = bluetooth_services_device_get_icon (_tmp27_);
#line 162 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp29_ = _tmp28_;
#line 162 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp30_ = _tmp29_;
#line 162 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		g_object_set (_tmp26_, "icon-name", _tmp30_, NULL);
#line 162 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_g_free0 (_tmp30_);
#line 805 "DeviceRow.c"
	}
#line 145 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_variant_unref0 (icon);
#line 145 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_variant_unref0 (name);
#line 145 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_variant_unref0 (connected);
#line 813 "DeviceRow.c"
}


static void __bluetooth_device_row___lambda9__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender, GVariant* changed_properties, gchar** invalidated_properties, gpointer self) {
#line 145 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_bluetooth_device_row___lambda9_ (self, changed_properties, invalidated_properties, _vala_array_length (invalidated_properties));
#line 820 "DeviceRow.c"
}


static void* ___lambda11_ (BluetoothDeviceRow* self) {
	void* result = NULL;
	GError * _inner_error_ = NULL;
	{
		BluetoothServicesDevice* _tmp0_ = NULL;
#line 171 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp0_ = self->priv->_device;
#line 171 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		bluetooth_services_device_connect (_tmp0_, &_inner_error_);
#line 171 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 835 "DeviceRow.c"
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
#line 170 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		e = _inner_error_;
#line 170 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_inner_error_ = NULL;
#line 173 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT);
#line 174 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp1_ = e;
#line 174 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp2_ = _tmp1_->message;
#line 174 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		g_critical ("DeviceRow.vala:174: %s", _tmp2_);
#line 170 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_g_error_free0 (e);
#line 859 "DeviceRow.c"
	}
	__finally3:
#line 170 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 170 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 170 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		g_clear_error (&_inner_error_);
#line 170 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		return NULL;
#line 870 "DeviceRow.c"
	}
#line 176 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	result = NULL;
#line 176 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	return result;
#line 876 "DeviceRow.c"
}


static gpointer ____lambda11__gthread_func (gpointer self) {
	gpointer result;
	result = ___lambda11_ ((BluetoothDeviceRow*) self);
#line 169 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_unref (self);
#line 169 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	return result;
#line 887 "DeviceRow.c"
}


static void* ___lambda12_ (BluetoothDeviceRow* self) {
	void* result = NULL;
	GError * _inner_error_ = NULL;
	{
		BluetoothServicesDevice* _tmp0_ = NULL;
#line 182 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp0_ = self->priv->_device;
#line 182 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		bluetooth_services_device_disconnect (_tmp0_, &_inner_error_);
#line 182 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 902 "DeviceRow.c"
			goto __catch4_g_error;
		}
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GtkImage* _tmp1_ = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 181 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		e = _inner_error_;
#line 181 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_inner_error_ = NULL;
#line 184 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp1_ = self->priv->state;
#line 184 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		g_object_set (_tmp1_, "icon-name", "user-busy", NULL);
#line 185 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp2_ = e;
#line 185 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp3_ = _tmp2_->message;
#line 185 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		g_critical ("DeviceRow.vala:185: %s", _tmp3_);
#line 181 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_g_error_free0 (e);
#line 929 "DeviceRow.c"
	}
	__finally4:
#line 181 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 181 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 181 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		g_clear_error (&_inner_error_);
#line 181 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		return NULL;
#line 940 "DeviceRow.c"
	}
#line 187 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	result = NULL;
#line 187 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	return result;
#line 946 "DeviceRow.c"
}


static gpointer ____lambda12__gthread_func (gpointer self) {
	gpointer result;
	result = ___lambda12_ ((BluetoothDeviceRow*) self);
#line 180 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_unref (self);
#line 180 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	return result;
#line 957 "DeviceRow.c"
}


static void _bluetooth_device_row___lambda10_ (BluetoothDeviceRow* self) {
	BluetoothServicesDevice* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 167 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp0_ = self->priv->_device;
#line 167 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp1_ = bluetooth_services_device_get_connected (_tmp0_);
#line 167 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp2_ = _tmp1_;
#line 167 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	if (!_tmp2_) {
#line 973 "DeviceRow.c"
		GThread* _tmp3_ = NULL;
		GThread* _tmp4_ = NULL;
#line 168 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING);
#line 169 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp3_ = g_thread_new (NULL, ____lambda11__gthread_func, g_object_ref (self));
#line 169 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp4_ = _tmp3_;
#line 169 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_g_thread_unref0 (_tmp4_);
#line 984 "DeviceRow.c"
	} else {
		GThread* _tmp5_ = NULL;
		GThread* _tmp6_ = NULL;
#line 179 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING);
#line 180 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp5_ = g_thread_new (NULL, ____lambda12__gthread_func, g_object_ref (self));
#line 180 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_tmp6_ = _tmp5_;
#line 180 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		_g_thread_unref0 (_tmp6_);
#line 996 "DeviceRow.c"
	}
}


static void __bluetooth_device_row___lambda10__gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 166 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_bluetooth_device_row___lambda10_ ((BluetoothDeviceRow*) self);
#line 1004 "DeviceRow.c"
}


static GObject * bluetooth_device_row_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothDeviceRow * self;
	Block3Data* _data3_;
	BluetoothServicesDevice* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GtkImage* _tmp4_ = NULL;
	GtkImage* _tmp5_ = NULL;
	GtkImage* _tmp6_ = NULL;
	GtkImage* _tmp7_ = NULL;
	GtkImage* _tmp8_ = NULL;
	GtkLabel* _tmp9_ = NULL;
	GtkLabel* _tmp10_ = NULL;
	GtkLabel* _tmp11_ = NULL;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp12_ = NULL;
	GtkOverlay* _tmp13_ = NULL;
	BluetoothServicesDevice* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	GtkOverlay* _tmp18_ = NULL;
	GtkImage* _tmp19_ = NULL;
	GtkOverlay* _tmp20_ = NULL;
	GtkImage* _tmp21_ = NULL;
	BluetoothServicesDevice* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	gchar* _tmp24_ = NULL;
	gchar* _tmp25_ = NULL;
	GtkLabel* _tmp26_ = NULL;
	GtkLabel* _tmp27_ = NULL;
	GtkLabel* _tmp28_ = NULL;
	GtkLabel* _tmp29_ = NULL;
	GtkLabel* _tmp30_ = NULL;
	GtkLinkButton* settings_button = NULL;
	GtkLinkButton* _tmp31_ = NULL;
	GtkLinkButton* _tmp32_ = NULL;
	GtkLinkButton* _tmp33_ = NULL;
	GtkImage* _tmp34_ = NULL;
	GtkImage* _tmp35_ = NULL;
	GtkLinkButton* _tmp36_ = NULL;
	GtkLinkButton* _tmp37_ = NULL;
	GtkLinkButton* _tmp38_ = NULL;
	const gchar* _tmp39_ = NULL;
	GtkButton* _tmp40_ = NULL;
	GtkButton* _tmp41_ = NULL;
	GtkSizeGroup* _tmp42_ = NULL;
	GtkButton* _tmp43_ = NULL;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp44_ = NULL;
	GtkGrid* _tmp45_ = NULL;
	GtkGrid* _tmp46_ = NULL;
	GtkGrid* _tmp47_ = NULL;
	GtkGrid* _tmp48_ = NULL;
	GtkOverlay* _tmp49_ = NULL;
	GtkGrid* _tmp50_ = NULL;
	GtkLabel* _tmp51_ = NULL;
	GtkGrid* _tmp52_ = NULL;
	GtkLabel* _tmp53_ = NULL;
	GtkGrid* _tmp54_ = NULL;
	GtkLinkButton* _tmp55_ = NULL;
	GtkGrid* _tmp56_ = NULL;
	GtkButton* _tmp57_ = NULL;
	GtkGrid* _tmp58_ = NULL;
	BluetoothServicesDevice* _tmp59_ = NULL;
	gchar* _tmp60_ = NULL;
	gchar* _tmp61_ = NULL;
	gchar* _tmp62_ = NULL;
	GQuark _tmp64_ = 0U;
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	static GQuark _tmp63_label0 = 0;
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	static GQuark _tmp63_label1 = 0;
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	static GQuark _tmp63_label2 = 0;
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	static GQuark _tmp63_label3 = 0;
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	static GQuark _tmp63_label4 = 0;
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	static GQuark _tmp63_label5 = 0;
#line 1092 "DeviceRow.c"
	BluetoothServicesDevice* _tmp80_ = NULL;
	gboolean _tmp81_ = FALSE;
	gboolean _tmp82_ = FALSE;
	BluetoothServicesAdapter* _tmp83_ = NULL;
	gboolean _tmp84_ = FALSE;
	gboolean _tmp85_ = FALSE;
	BluetoothServicesAdapter* _tmp86_ = NULL;
	BluetoothServicesDevice* _tmp87_ = NULL;
	GtkButton* _tmp88_ = NULL;
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	parent_class = G_OBJECT_CLASS (bluetooth_device_row_parent_class);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_data3_->_ref_count_ = 1;
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_data3_->self = g_object_ref (self);
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp0_ = self->priv->_device;
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp1_ = bluetooth_services_device_get_icon (_tmp0_);
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp2_ = _tmp1_;
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp3_ = _tmp2_;
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp3_, GTK_ICON_SIZE_DND);
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_ref_sink (_tmp4_);
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp5_ = _tmp4_;
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_free0 (_tmp3_);
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_data3_->image = _tmp5_;
#line 64 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp6_ = (GtkImage*) gtk_image_new_from_icon_name ("user-offline", GTK_ICON_SIZE_MENU);
#line 64 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_ref_sink (_tmp6_);
#line 64 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (self->priv->state);
#line 64 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	self->priv->state = _tmp6_;
#line 65 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp7_ = self->priv->state;
#line 65 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp7_, GTK_ALIGN_END);
#line 66 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp8_ = self->priv->state;
#line 66 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_END);
#line 68 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp9_ = (GtkLabel*) gtk_label_new (NULL);
#line 68 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_ref_sink (_tmp9_);
#line 68 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (self->priv->state_label);
#line 68 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	self->priv->state_label = _tmp9_;
#line 69 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp10_ = self->priv->state_label;
#line 69 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_label_set_xalign (_tmp10_, (gfloat) 0);
#line 70 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp11_ = self->priv->state_label;
#line 70 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_label_set_use_markup (_tmp11_, TRUE);
#line 72 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp12_ = (GtkOverlay*) gtk_overlay_new ();
#line 72 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_ref_sink (_tmp12_);
#line 72 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	overlay = _tmp12_;
#line 73 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp13_ = overlay;
#line 73 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp14_ = self->priv->_device;
#line 73 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp15_ = bluetooth_services_device_get_address (_tmp14_);
#line 73 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp16_ = _tmp15_;
#line 73 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp17_ = _tmp16_;
#line 73 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _tmp17_);
#line 73 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_free0 (_tmp17_);
#line 74 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp18_ = overlay;
#line 74 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp19_ = _data3_->image;
#line 74 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
#line 75 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp20_ = overlay;
#line 75 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp21_ = self->priv->state;
#line 75 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_overlay_add_overlay (_tmp20_, (GtkWidget*) _tmp21_);
#line 77 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp22_ = self->priv->_device;
#line 77 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp23_ = bluetooth_services_device_get_name (_tmp22_);
#line 77 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp24_ = _tmp23_;
#line 77 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp25_ = _tmp24_;
#line 77 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp26_ = (GtkLabel*) gtk_label_new (_tmp25_);
#line 77 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_ref_sink (_tmp26_);
#line 77 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp27_ = _tmp26_;
#line 77 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_free0 (_tmp25_);
#line 77 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_data3_->label = _tmp27_;
#line 78 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp28_ = _data3_->label;
#line 78 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_label_set_ellipsize (_tmp28_, PANGO_ELLIPSIZE_END);
#line 79 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp29_ = _data3_->label;
#line 79 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp29_, TRUE);
#line 80 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp30_ = _data3_->label;
#line 80 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_label_set_xalign (_tmp30_, (gfloat) 0);
#line 82 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp31_ = (GtkLinkButton*) gtk_link_button_new ("settings://network/share/bluetooth");
#line 82 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_ref_sink (_tmp31_);
#line 82 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	settings_button = _tmp31_;
#line 83 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp32_ = settings_button;
#line 83 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_button_set_always_show_image ((GtkButton*) _tmp32_, TRUE);
#line 84 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp33_ = settings_button;
#line 84 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp34_ = (GtkImage*) gtk_image_new_from_icon_name ("view-more-horizontal-symbolic", GTK_ICON_SIZE_MENU);
#line 84 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_ref_sink (_tmp34_);
#line 84 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp35_ = _tmp34_;
#line 84 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_button_set_image ((GtkButton*) _tmp33_, (GtkWidget*) _tmp35_);
#line 84 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (_tmp35_);
#line 85 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp36_ = settings_button;
#line 85 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_button_set_label ((GtkButton*) _tmp36_, NULL);
#line 86 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp37_ = settings_button;
#line 86 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp37_, 3);
#line 87 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp38_ = settings_button;
#line 87 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp39_ = _ ("Sharing Settings");
#line 87 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp38_, _tmp39_);
#line 89 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp40_ = (GtkButton*) gtk_button_new ();
#line 89 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_ref_sink (_tmp40_);
#line 89 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (self->priv->connect_button);
#line 89 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	self->priv->connect_button = _tmp40_;
#line 90 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp41_ = self->priv->connect_button;
#line 90 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp41_, GTK_ALIGN_CENTER);
#line 91 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp42_ = bluetooth_device_row_size_group;
#line 91 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp43_ = self->priv->connect_button;
#line 91 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_size_group_add_widget (_tmp42_, (GtkWidget*) _tmp43_);
#line 93 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp44_ = (GtkGrid*) gtk_grid_new ();
#line 93 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_ref_sink (_tmp44_);
#line 93 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	grid = _tmp44_;
#line 94 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp45_ = grid;
#line 94 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_set ((GtkWidget*) _tmp45_, "margin", 6, NULL);
#line 95 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp46_ = grid;
#line 95 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_grid_set_column_spacing (_tmp46_, 6);
#line 96 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp47_ = grid;
#line 96 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp47_, GTK_ORIENTATION_HORIZONTAL);
#line 97 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp48_ = grid;
#line 97 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp49_ = overlay;
#line 97 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_grid_attach (_tmp48_, (GtkWidget*) _tmp49_, 0, 0, 1, 2);
#line 98 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp50_ = grid;
#line 98 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp51_ = _data3_->label;
#line 98 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_grid_attach (_tmp50_, (GtkWidget*) _tmp51_, 1, 0, 1, 1);
#line 99 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp52_ = grid;
#line 99 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp53_ = self->priv->state_label;
#line 99 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_grid_attach (_tmp52_, (GtkWidget*) _tmp53_, 1, 1, 1, 1);
#line 100 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp54_ = grid;
#line 100 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp55_ = settings_button;
#line 100 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_grid_attach (_tmp54_, (GtkWidget*) _tmp55_, 2, 0, 1, 2);
#line 101 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp56_ = grid;
#line 101 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp57_ = self->priv->connect_button;
#line 101 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_grid_attach (_tmp56_, (GtkWidget*) _tmp57_, 3, 0, 1, 2);
#line 103 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp58_ = grid;
#line 103 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp58_);
#line 104 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp59_ = self->priv->_device;
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp60_ = bluetooth_services_device_get_icon (_tmp59_);
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp61_ = _tmp60_;
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp62_ = _tmp61_;
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp64_ = (NULL == _tmp62_) ? 0 : g_quark_from_string (_tmp62_);
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_free (_tmp62_);
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	if (_tmp64_ == ((0 != _tmp63_label0) ? _tmp63_label0 : (_tmp63_label0 = g_quark_from_static_string ("audio-card")))) {
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		switch (0) {
#line 1350 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp65_ = NULL;
				GtkLinkButton* _tmp66_ = NULL;
				const gchar* _tmp67_ = NULL;
#line 108 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp65_ = settings_button;
#line 108 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp65_, "settings://sound");
#line 109 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp66_ = settings_button;
#line 109 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp67_ = _ ("Sound Settings");
#line 109 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp66_, _tmp67_);
#line 110 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				break;
#line 1368 "DeviceRow.c"
			}
		}
	} else if ((_tmp64_ == ((0 != _tmp63_label1) ? _tmp63_label1 : (_tmp63_label1 = g_quark_from_static_string ("input-gaming")))) || (_tmp64_ == ((0 != _tmp63_label2) ? _tmp63_label2 : (_tmp63_label2 = g_quark_from_static_string ("input-keyboard"))))) {
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		switch (0) {
#line 1374 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp68_ = NULL;
				GtkLinkButton* _tmp69_ = NULL;
				const gchar* _tmp70_ = NULL;
#line 113 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp68_ = settings_button;
#line 113 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp68_, "settings://input/keyboard");
#line 114 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp69_ = settings_button;
#line 114 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp70_ = _ ("Keyboard Settings");
#line 114 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp69_, _tmp70_);
#line 115 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				break;
#line 1392 "DeviceRow.c"
			}
		}
	} else if (_tmp64_ == ((0 != _tmp63_label3) ? _tmp63_label3 : (_tmp63_label3 = g_quark_from_static_string ("input-mouse")))) {
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		switch (0) {
#line 1398 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp71_ = NULL;
				GtkLinkButton* _tmp72_ = NULL;
				const gchar* _tmp73_ = NULL;
#line 117 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp71_ = settings_button;
#line 117 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp71_, "settings://input/mouse");
#line 118 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp72_ = settings_button;
#line 118 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp73_ = _ ("Mouse & Touchpad Settings");
#line 118 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp72_, _tmp73_);
#line 119 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				break;
#line 1416 "DeviceRow.c"
			}
		}
	} else if (_tmp64_ == ((0 != _tmp63_label4) ? _tmp63_label4 : (_tmp63_label4 = g_quark_from_static_string ("input-tablet")))) {
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		switch (0) {
#line 1422 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp74_ = NULL;
				GtkLinkButton* _tmp75_ = NULL;
				const gchar* _tmp76_ = NULL;
#line 121 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp74_ = settings_button;
#line 121 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp74_, "settings://input/wacom");
#line 122 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp75_ = settings_button;
#line 122 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp76_ = _ ("Drawing Tablet Settings");
#line 122 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp75_, _tmp76_);
#line 123 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				break;
#line 1440 "DeviceRow.c"
			}
		}
	} else if (_tmp64_ == ((0 != _tmp63_label5) ? _tmp63_label5 : (_tmp63_label5 = g_quark_from_static_string ("printer")))) {
#line 106 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		switch (0) {
#line 1446 "DeviceRow.c"
			default:
			{
				GtkLinkButton* _tmp77_ = NULL;
				GtkLinkButton* _tmp78_ = NULL;
				const gchar* _tmp79_ = NULL;
#line 125 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp77_ = settings_button;
#line 125 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				gtk_link_button_set_uri (_tmp77_, "settings://printer");
#line 126 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp78_ = settings_button;
#line 126 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				_tmp79_ = _ ("Printer Settings");
#line 126 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp78_, _tmp79_);
#line 127 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
				break;
#line 1464 "DeviceRow.c"
			}
		}
	}
#line 130 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp80_ = self->priv->_device;
#line 130 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp81_ = bluetooth_services_device_get_connected (_tmp80_);
#line 130 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp82_ = _tmp81_;
#line 130 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	if (_tmp82_) {
#line 131 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED);
#line 1478 "DeviceRow.c"
	} else {
#line 133 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED);
#line 1482 "DeviceRow.c"
	}
#line 136 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp83_ = self->priv->_adapter;
#line 136 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp84_ = bluetooth_services_adapter_get_powered (_tmp83_);
#line 136 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp85_ = _tmp84_;
#line 136 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp85_);
#line 138 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp86_ = self->priv->_adapter;
#line 138 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_TYPE (_tmp86_, G_TYPE_DBUS_PROXY) ? ((GDBusProxy*) _tmp86_) : NULL, "g-properties-changed", (GCallback) __bluetooth_device_row___lambda8__g_dbus_proxy_g_properties_changed, self, 0);
#line 145 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp87_ = self->priv->_device;
#line 145 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_TYPE (_tmp87_, G_TYPE_DBUS_PROXY) ? ((GDBusProxy*) _tmp87_) : NULL, "g-properties-changed", (GCallback) __bluetooth_device_row___lambda9__g_dbus_proxy_g_properties_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 166 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp88_ = self->priv->connect_button;
#line 166 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_signal_connect_object (_tmp88_, "clicked", (GCallback) __bluetooth_device_row___lambda10__gtk_button_clicked, self, 0);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (grid);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (settings_button);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (overlay);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	block3_data_unref (_data3_);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_data3_ = NULL;
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	return obj;
#line 1516 "DeviceRow.c"
}


static void bluetooth_device_row_class_init (BluetoothDeviceRowClass * klass) {
	GtkSizeGroup* _tmp0_ = NULL;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	bluetooth_device_row_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_type_class_add_private (klass, sizeof (BluetoothDeviceRowPrivate));
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_device_row_get_property;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_device_row_set_property;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->constructor = bluetooth_device_row_constructor;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_device_row_finalize;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_DEVICE, g_param_spec_object ("device", "device", "device", BLUETOOTH_SERVICES_TYPE_DEVICE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_ADAPTER, g_param_spec_object ("adapter", "adapter", "adapter", BLUETOOTH_SERVICES_TYPE_ADAPTER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 58 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_tmp0_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
#line 58 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (bluetooth_device_row_size_group);
#line 58 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	bluetooth_device_row_size_group = _tmp0_;
#line 1544 "DeviceRow.c"
}


static void bluetooth_device_row_instance_init (BluetoothDeviceRow * self) {
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	self->priv = BLUETOOTH_DEVICE_ROW_GET_PRIVATE (self);
#line 1551 "DeviceRow.c"
}


static void bluetooth_device_row_finalize (GObject* obj) {
	BluetoothDeviceRow * self;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (self->priv->_device);
#line 49 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (self->priv->connect_button);
#line 50 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (self->priv->state);
#line 51 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	_g_object_unref0 (self->priv->state_label);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	G_OBJECT_CLASS (bluetooth_device_row_parent_class)->finalize (obj);
#line 1569 "DeviceRow.c"
}


GType bluetooth_device_row_get_type (void) {
	static volatile gsize bluetooth_device_row_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_device_row_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BluetoothDeviceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_device_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothDeviceRow), 0, (GInstanceInitFunc) bluetooth_device_row_instance_init, NULL };
		GType bluetooth_device_row_type_id;
		bluetooth_device_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "BluetoothDeviceRow", &g_define_type_info, 0);
		g_once_init_leave (&bluetooth_device_row_type_id__volatile, bluetooth_device_row_type_id);
	}
	return bluetooth_device_row_type_id__volatile;
}


static void _vala_bluetooth_device_row_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_DEVICE:
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		g_value_set_object (value, bluetooth_device_row_get_device (self));
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_ADAPTER:
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		g_value_set_object (value, bluetooth_device_row_get_adapter (self));
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		break;
#line 1602 "DeviceRow.c"
		default:
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		break;
#line 1608 "DeviceRow.c"
	}
}


static void _vala_bluetooth_device_row_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_DEVICE:
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		bluetooth_device_row_set_device (self, g_value_get_object (value));
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		break;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		case BLUETOOTH_DEVICE_ROW_ADAPTER:
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		bluetooth_device_row_set_adapter (self, g_value_get_object (value));
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		break;
#line 1630 "DeviceRow.c"
		default:
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/DeviceRow.vala"
		break;
#line 1636 "DeviceRow.c"
	}
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



