/* HeaderAdapter.c generated by valac 0.34.4, the Vala compiler
 * generated from HeaderAdapter.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>


#define BLUETOOTH_TYPE_HEADER_ADAPTER (bluetooth_header_adapter_get_type ())
#define BLUETOOTH_HEADER_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_TYPE_HEADER_ADAPTER, BluetoothHeaderAdapter))
#define BLUETOOTH_HEADER_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BLUETOOTH_TYPE_HEADER_ADAPTER, BluetoothHeaderAdapterClass))
#define BLUETOOTH_IS_HEADER_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_TYPE_HEADER_ADAPTER))
#define BLUETOOTH_IS_HEADER_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BLUETOOTH_TYPE_HEADER_ADAPTER))
#define BLUETOOTH_HEADER_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BLUETOOTH_TYPE_HEADER_ADAPTER, BluetoothHeaderAdapterClass))

typedef struct _BluetoothHeaderAdapter BluetoothHeaderAdapter;
typedef struct _BluetoothHeaderAdapterClass BluetoothHeaderAdapterClass;
typedef struct _BluetoothHeaderAdapterPrivate BluetoothHeaderAdapterPrivate;

#define BLUETOOTH_SERVICES_TYPE_ADAPTER (bluetooth_services_adapter_get_type ())
#define BLUETOOTH_SERVICES_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapter))
#define BLUETOOTH_SERVICES_IS_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER))
#define BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapterIface))

typedef struct _BluetoothServicesAdapter BluetoothServicesAdapter;
typedef struct _BluetoothServicesAdapterIface BluetoothServicesAdapterIface;

#define BLUETOOTH_SERVICES_TYPE_ADAPTER_PROXY (bluetooth_services_adapter_proxy_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _BluetoothHeaderAdapter {
	GtkGrid parent_instance;
	BluetoothHeaderAdapterPrivate * priv;
};

struct _BluetoothHeaderAdapterClass {
	GtkGridClass parent_class;
};

struct _BluetoothServicesAdapterIface {
	GTypeInterface parent_iface;
	void (*remove_device) (BluetoothServicesAdapter* self, const char* device, GError** error);
	void (*set_discovery_filter) (BluetoothServicesAdapter* self, GHashTable* properties, GError** error);
	void (*start_discovery) (BluetoothServicesAdapter* self, GError** error);
	void (*stop_discovery) (BluetoothServicesAdapter* self, GError** error);
	gchar** (*get_UUIDs) (BluetoothServicesAdapter* self, int* result_length1);
	void (*set_UUIDs) (BluetoothServicesAdapter* self, gchar** value, int value_length1);
	gboolean (*get_discoverable) (BluetoothServicesAdapter* self);
	void (*set_discoverable) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_discovering) (BluetoothServicesAdapter* self);
	void (*set_discovering) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_pairable) (BluetoothServicesAdapter* self);
	void (*set_pairable) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_powered) (BluetoothServicesAdapter* self);
	void (*set_powered) (BluetoothServicesAdapter* self, gboolean value);
	gchar* (*get_address) (BluetoothServicesAdapter* self);
	void (*set_address) (BluetoothServicesAdapter* self, const gchar* value);
	gchar* (*get_alias) (BluetoothServicesAdapter* self);
	void (*set_alias) (BluetoothServicesAdapter* self, const gchar* value);
	gchar* (*get_modalias) (BluetoothServicesAdapter* self);
	void (*set_modalias) (BluetoothServicesAdapter* self, const gchar* value);
	gchar* (*get_name) (BluetoothServicesAdapter* self);
	void (*set_name) (BluetoothServicesAdapter* self, const gchar* value);
	guint (*get_class) (BluetoothServicesAdapter* self);
	void (*set_class) (BluetoothServicesAdapter* self, guint value);
	guint (*get_discoverable_timeout) (BluetoothServicesAdapter* self);
	void (*set_discoverable_timeout) (BluetoothServicesAdapter* self, guint value);
	guint (*get_pairable_timeout) (BluetoothServicesAdapter* self);
	void (*set_pairable_timeout) (BluetoothServicesAdapter* self, guint value);
};

struct _BluetoothHeaderAdapterPrivate {
	BluetoothServicesAdapter* _adapter;
	GtkLabel* label;
	GtkSwitch* adapter_switch;
};


static gpointer bluetooth_header_adapter_parent_class = NULL;

GType bluetooth_header_adapter_get_type (void) G_GNUC_CONST;
GType bluetooth_services_adapter_proxy_get_type (void) G_GNUC_CONST;
guint bluetooth_services_adapter_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType bluetooth_services_adapter_get_type (void) G_GNUC_CONST;
#define BLUETOOTH_HEADER_ADAPTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), BLUETOOTH_TYPE_HEADER_ADAPTER, BluetoothHeaderAdapterPrivate))
enum  {
	BLUETOOTH_HEADER_ADAPTER_DUMMY_PROPERTY,
	BLUETOOTH_HEADER_ADAPTER_ADAPTER
};
BluetoothHeaderAdapter* bluetooth_header_adapter_new (BluetoothServicesAdapter* adapter);
BluetoothHeaderAdapter* bluetooth_header_adapter_construct (GType object_type, BluetoothServicesAdapter* adapter);
BluetoothServicesAdapter* bluetooth_header_adapter_get_adapter (BluetoothHeaderAdapter* self);
static void bluetooth_header_adapter_set_adapter (BluetoothHeaderAdapter* self, BluetoothServicesAdapter* value);
static GObject * bluetooth_header_adapter_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
gchar* bluetooth_services_adapter_get_name (BluetoothServicesAdapter* self);
gboolean bluetooth_services_adapter_get_powered (BluetoothServicesAdapter* self);
static void _bluetooth_header_adapter___lambda16_ (BluetoothHeaderAdapter* self, GVariant* changed, gchar** invalid, int invalid_length1);
static void __bluetooth_header_adapter___lambda16__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender, GVariant* changed_properties, gchar** invalidated_properties, gpointer self);
static void _bluetooth_header_adapter___lambda17_ (BluetoothHeaderAdapter* self);
void bluetooth_services_adapter_set_powered (BluetoothServicesAdapter* self, gboolean value);
static void __bluetooth_header_adapter___lambda17__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void bluetooth_header_adapter_finalize (GObject* obj);
static void _vala_bluetooth_header_adapter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_bluetooth_header_adapter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static gint _vala_array_length (gpointer array);


BluetoothHeaderAdapter* bluetooth_header_adapter_construct (GType object_type, BluetoothServicesAdapter* adapter) {
	BluetoothHeaderAdapter * self = NULL;
	BluetoothServicesAdapter* _tmp0_ = NULL;
#line 26 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	g_return_val_if_fail (adapter != NULL, NULL);
#line 27 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp0_ = adapter;
#line 27 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	self = (BluetoothHeaderAdapter*) g_object_new (object_type, "adapter", _tmp0_, NULL);
#line 26 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	return self;
#line 150 "HeaderAdapter.c"
}


BluetoothHeaderAdapter* bluetooth_header_adapter_new (BluetoothServicesAdapter* adapter) {
#line 26 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	return bluetooth_header_adapter_construct (BLUETOOTH_TYPE_HEADER_ADAPTER, adapter);
#line 157 "HeaderAdapter.c"
}


BluetoothServicesAdapter* bluetooth_header_adapter_get_adapter (BluetoothHeaderAdapter* self) {
	BluetoothServicesAdapter* result;
	BluetoothServicesAdapter* _tmp0_ = NULL;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp0_ = self->priv->_adapter;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	result = _tmp0_;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	return result;
#line 172 "HeaderAdapter.c"
}


static void bluetooth_header_adapter_set_adapter (BluetoothHeaderAdapter* self, BluetoothServicesAdapter* value) {
	BluetoothServicesAdapter* _tmp0_ = NULL;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	g_return_if_fail (self != NULL);
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp0_ = value;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	self->priv->_adapter = _tmp0_;
#line 22 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	g_object_notify ((GObject *) self, "adapter");
#line 186 "HeaderAdapter.c"
}


static void _bluetooth_header_adapter___lambda16_ (BluetoothHeaderAdapter* self, GVariant* changed, gchar** invalid, int invalid_length1) {
	GVariant* powered = NULL;
	GVariant* _tmp0_ = NULL;
	GVariantType* _tmp1_ = NULL;
	GVariantType* _tmp2_ = NULL;
	GVariant* _tmp3_ = NULL;
	GVariant* _tmp4_ = NULL;
	GVariant* _tmp5_ = NULL;
	GVariant* name = NULL;
	GVariant* _tmp10_ = NULL;
	GVariantType* _tmp11_ = NULL;
	GVariantType* _tmp12_ = NULL;
	GVariant* _tmp13_ = NULL;
	GVariant* _tmp14_ = NULL;
	GVariant* _tmp15_ = NULL;
#line 49 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	g_return_if_fail (changed != NULL);
#line 50 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp0_ = changed;
#line 50 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp1_ = g_variant_type_new ("b");
#line 50 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp2_ = _tmp1_;
#line 50 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp3_ = g_variant_lookup_value (_tmp0_, "Powered", _tmp2_);
#line 50 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp4_ = _tmp3_;
#line 50 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_g_variant_type_free0 (_tmp2_);
#line 50 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	powered = _tmp4_;
#line 51 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp5_ = powered;
#line 51 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	if (_tmp5_ != NULL) {
#line 225 "HeaderAdapter.c"
		GtkSwitch* _tmp6_ = NULL;
		BluetoothServicesAdapter* _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
#line 52 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp6_ = self->priv->adapter_switch;
#line 52 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp7_ = self->priv->_adapter;
#line 52 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp8_ = bluetooth_services_adapter_get_powered (_tmp7_);
#line 52 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp9_ = _tmp8_;
#line 52 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		gtk_switch_set_active (_tmp6_, _tmp9_);
#line 240 "HeaderAdapter.c"
	}
#line 55 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp10_ = changed;
#line 55 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp11_ = g_variant_type_new ("s");
#line 55 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp12_ = _tmp11_;
#line 55 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp13_ = g_variant_lookup_value (_tmp10_, "Name", _tmp12_);
#line 55 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp14_ = _tmp13_;
#line 55 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_g_variant_type_free0 (_tmp12_);
#line 55 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	name = _tmp14_;
#line 56 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp15_ = name;
#line 56 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	if (_tmp15_ != NULL) {
#line 260 "HeaderAdapter.c"
		GtkLabel* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		BluetoothServicesAdapter* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
		gchar* _tmp23_ = NULL;
#line 57 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp16_ = self->priv->label;
#line 57 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp17_ = _ ("Now Discoverable as \"%s\"");
#line 57 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp18_ = self->priv->_adapter;
#line 57 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp19_ = bluetooth_services_adapter_get_name (_tmp18_);
#line 57 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp20_ = _tmp19_;
#line 57 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp21_ = _tmp20_;
#line 57 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp22_ = g_strdup_printf (_tmp17_, _tmp21_);
#line 57 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp23_ = _tmp22_;
#line 57 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		gtk_label_set_label (_tmp16_, _tmp23_);
#line 57 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_g_free0 (_tmp23_);
#line 57 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_g_free0 (_tmp21_);
#line 291 "HeaderAdapter.c"
	}
#line 49 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_g_variant_unref0 (name);
#line 49 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_g_variant_unref0 (powered);
#line 297 "HeaderAdapter.c"
}


static void __bluetooth_header_adapter___lambda16__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender, GVariant* changed_properties, gchar** invalidated_properties, gpointer self) {
#line 49 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_bluetooth_header_adapter___lambda16_ ((BluetoothHeaderAdapter*) self, changed_properties, invalidated_properties, _vala_array_length (invalidated_properties));
#line 304 "HeaderAdapter.c"
}


static void _bluetooth_header_adapter___lambda17_ (BluetoothHeaderAdapter* self) {
	GtkSwitch* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	BluetoothServicesAdapter* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp0_ = self->priv->adapter_switch;
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp1_ = gtk_switch_get_active (_tmp0_);
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp2_ = _tmp1_;
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp3_ = self->priv->_adapter;
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp4_ = bluetooth_services_adapter_get_powered (_tmp3_);
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp5_ = _tmp4_;
#line 62 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	if (_tmp2_ & (!_tmp5_)) {
#line 329 "HeaderAdapter.c"
		BluetoothServicesAdapter* _tmp6_ = NULL;
#line 63 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp6_ = self->priv->_adapter;
#line 63 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		bluetooth_services_adapter_set_powered (_tmp6_, TRUE);
#line 335 "HeaderAdapter.c"
	} else {
		GtkSwitch* _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		BluetoothServicesAdapter* _tmp10_ = NULL;
		gboolean _tmp11_ = FALSE;
		gboolean _tmp12_ = FALSE;
#line 64 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp7_ = self->priv->adapter_switch;
#line 64 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp8_ = gtk_switch_get_active (_tmp7_);
#line 64 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp9_ = _tmp8_;
#line 64 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp10_ = self->priv->_adapter;
#line 64 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp11_ = bluetooth_services_adapter_get_powered (_tmp10_);
#line 64 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		_tmp12_ = _tmp11_;
#line 64 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		if ((!_tmp9_) & _tmp12_) {
#line 357 "HeaderAdapter.c"
			BluetoothServicesAdapter* _tmp13_ = NULL;
#line 65 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
			_tmp13_ = self->priv->_adapter;
#line 65 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
			bluetooth_services_adapter_set_powered (_tmp13_, FALSE);
#line 363 "HeaderAdapter.c"
		}
	}
}


static void __bluetooth_header_adapter___lambda17__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_bluetooth_header_adapter___lambda17_ ((BluetoothHeaderAdapter*) self);
#line 372 "HeaderAdapter.c"
}


static GObject * bluetooth_header_adapter_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothHeaderAdapter * self;
	const gchar* _tmp0_ = NULL;
	BluetoothServicesAdapter* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GtkLabel* _tmp7_ = NULL;
	GtkLabel* _tmp8_ = NULL;
	GtkStyleContext* _tmp9_ = NULL;
	GtkLabel* _tmp10_ = NULL;
	GtkLabel* _tmp11_ = NULL;
	GtkLabel* _tmp12_ = NULL;
	GtkLabel* _tmp13_ = NULL;
	GtkSwitch* _tmp14_ = NULL;
	GtkSwitch* _tmp15_ = NULL;
	BluetoothServicesAdapter* _tmp16_ = NULL;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	GtkSwitch* _tmp19_ = NULL;
	GtkSwitch* _tmp20_ = NULL;
	GtkLabel* _tmp21_ = NULL;
	GtkSwitch* _tmp22_ = NULL;
	BluetoothServicesAdapter* _tmp23_ = NULL;
	GtkSwitch* _tmp24_ = NULL;
#line 30 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	parent_class = G_OBJECT_CLASS (bluetooth_header_adapter_parent_class);
#line 30 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 30 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_HEADER_ADAPTER, BluetoothHeaderAdapter);
#line 31 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	g_object_set ((GtkWidget*) self, "margin", 3, NULL);
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp0_ = _ ("Now Discoverable as \"%s\"");
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp1_ = self->priv->_adapter;
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp2_ = bluetooth_services_adapter_get_name (_tmp1_);
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp3_ = _tmp2_;
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp4_ = _tmp3_;
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp5_ = g_strdup_printf (_tmp0_, _tmp4_);
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp6_ = _tmp5_;
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new (_tmp6_);
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	g_object_ref_sink (_tmp7_);
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_g_object_unref0 (self->priv->label);
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	self->priv->label = _tmp7_;
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_g_free0 (_tmp6_);
#line 33 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_g_free0 (_tmp4_);
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp8_ = self->priv->label;
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp9_ = gtk_widget_get_style_context ((GtkWidget*) _tmp8_);
#line 34 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	gtk_style_context_add_class (_tmp9_, "h4");
#line 35 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp10_ = self->priv->label;
#line 35 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp10_, TRUE);
#line 36 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp11_ = self->priv->label;
#line 36 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	gtk_label_set_xalign (_tmp11_, (gfloat) 0);
#line 37 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp12_ = self->priv->label;
#line 37 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp12_, GTK_ALIGN_CENTER);
#line 38 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp13_ = self->priv->label;
#line 38 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	gtk_label_set_ellipsize (_tmp13_, PANGO_ELLIPSIZE_END);
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp14_ = (GtkSwitch*) gtk_switch_new ();
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	g_object_ref_sink (_tmp14_);
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_g_object_unref0 (self->priv->adapter_switch);
#line 40 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	self->priv->adapter_switch = _tmp14_;
#line 41 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp15_ = self->priv->adapter_switch;
#line 41 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp16_ = self->priv->_adapter;
#line 41 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp17_ = bluetooth_services_adapter_get_powered (_tmp16_);
#line 41 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp18_ = _tmp17_;
#line 41 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	gtk_switch_set_active (_tmp15_, _tmp18_);
#line 42 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp19_ = self->priv->adapter_switch;
#line 42 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp19_, 3);
#line 43 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp20_ = self->priv->adapter_switch;
#line 43 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp20_, GTK_ALIGN_CENTER);
#line 45 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp21_ = self->priv->label;
#line 45 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp21_);
#line 46 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp22_ = self->priv->adapter_switch;
#line 46 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp22_);
#line 47 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 49 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp23_ = self->priv->_adapter;
#line 49 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, G_TYPE_DBUS_PROXY) ? ((GDBusProxy*) _tmp23_) : NULL, "g-properties-changed", (GCallback) __bluetooth_header_adapter___lambda16__g_dbus_proxy_g_properties_changed, self, 0);
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_tmp24_ = self->priv->adapter_switch;
#line 61 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	g_signal_connect_object ((GObject*) _tmp24_, "notify::active", (GCallback) __bluetooth_header_adapter___lambda17__g_object_notify, self, 0);
#line 30 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	return obj;
#line 507 "HeaderAdapter.c"
}


static void bluetooth_header_adapter_class_init (BluetoothHeaderAdapterClass * klass) {
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	bluetooth_header_adapter_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	g_type_class_add_private (klass, sizeof (BluetoothHeaderAdapterPrivate));
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_header_adapter_get_property;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_header_adapter_set_property;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	G_OBJECT_CLASS (klass)->constructor = bluetooth_header_adapter_constructor;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	G_OBJECT_CLASS (klass)->finalize = bluetooth_header_adapter_finalize;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_HEADER_ADAPTER_ADAPTER, g_param_spec_object ("adapter", "adapter", "adapter", BLUETOOTH_SERVICES_TYPE_ADAPTER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 526 "HeaderAdapter.c"
}


static void bluetooth_header_adapter_instance_init (BluetoothHeaderAdapter * self) {
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	self->priv = BLUETOOTH_HEADER_ADAPTER_GET_PRIVATE (self);
#line 533 "HeaderAdapter.c"
}


static void bluetooth_header_adapter_finalize (GObject* obj) {
	BluetoothHeaderAdapter * self;
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_HEADER_ADAPTER, BluetoothHeaderAdapter);
#line 23 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_g_object_unref0 (self->priv->label);
#line 24 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	_g_object_unref0 (self->priv->adapter_switch);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	G_OBJECT_CLASS (bluetooth_header_adapter_parent_class)->finalize (obj);
#line 547 "HeaderAdapter.c"
}


GType bluetooth_header_adapter_get_type (void) {
	static volatile gsize bluetooth_header_adapter_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_header_adapter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BluetoothHeaderAdapterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_header_adapter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothHeaderAdapter), 0, (GInstanceInitFunc) bluetooth_header_adapter_instance_init, NULL };
		GType bluetooth_header_adapter_type_id;
		bluetooth_header_adapter_type_id = g_type_register_static (gtk_grid_get_type (), "BluetoothHeaderAdapter", &g_define_type_info, 0);
		g_once_init_leave (&bluetooth_header_adapter_type_id__volatile, bluetooth_header_adapter_type_id);
	}
	return bluetooth_header_adapter_type_id__volatile;
}


static void _vala_bluetooth_header_adapter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	BluetoothHeaderAdapter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_HEADER_ADAPTER, BluetoothHeaderAdapter);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		case BLUETOOTH_HEADER_ADAPTER_ADAPTER:
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		g_value_set_object (value, bluetooth_header_adapter_get_adapter (self));
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		break;
#line 574 "HeaderAdapter.c"
		default:
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		break;
#line 580 "HeaderAdapter.c"
	}
}


static void _vala_bluetooth_header_adapter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	BluetoothHeaderAdapter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_HEADER_ADAPTER, BluetoothHeaderAdapter);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		case BLUETOOTH_HEADER_ADAPTER_ADAPTER:
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		bluetooth_header_adapter_set_adapter (self, g_value_get_object (value));
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		break;
#line 596 "HeaderAdapter.c"
		default:
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/switchboard-plug-bluetooth-0.1/src/HeaderAdapter.vala"
		break;
#line 602 "HeaderAdapter.c"
	}
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



